package nl.amis.app.view;


import javax.annotation.PostConstruct;

import javax.faces.event.ActionEvent;

import oracle.adf.model.BindingContext;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCIteratorBinding;
import oracle.adf.view.rich.context.AdfFacesContext;
import oracle.adf.view.rich.render.ClientEvent;

import oracle.binding.BindingContainer;
import oracle.binding.OperationBinding;

public class DataRefresher

    implements DataUpdateListenerI {

    private Boolean needsRefreshing = false;
    private DatabaseNotificationProcessor databaseNotificationProcessor;

    public void buttonHandler(ActionEvent ae) {
                boolean result = needsRefreshing;
                if (needsRefreshing) {
                    refreshDataFromTable(null);
                    
                }
                needsRefreshing = false;
    }
    public void refreshIfNeeded(ClientEvent ce) {
                boolean result = needsRefreshing;
                if (needsRefreshing) {
                    refreshDataFromTable(null);
                    
                }
                needsRefreshing = false;
    }



    @PostConstruct
    public void initializeBean() {
        System.out.println("add bean as listener");
        databaseNotificationProcessor.registerAsListener(this);
    }

    private String iteratorName = "EmpView1Iterator";

    public void refreshDataFromTable(ClientEvent clientEvent) {
        BindingContext bindingContext = BindingContext.getCurrent();
        BindingContainer bindingContainer =
            bindingContext.getCurrentBindingsEntry();
        // refresh EmployeesView1Iterator
        if (bindingContainer instanceof DCBindingContainer) {
            DCIteratorBinding cIteratorBinding =
                ((DCBindingContainer)bindingContainer).findIteratorBinding(iteratorName);
            cIteratorBinding.getViewObject().clearCache();
            
            System.out.println("Clear Cache for VO EmployeesView1");
        }

    }

    public void setDatabaseNotificationProcessor(DatabaseNotificationProcessor databaseNotificationProcessor) {
        this.databaseNotificationProcessor = databaseNotificationProcessor;
    }

    public DatabaseNotificationProcessor getDatabaseNotificationProcessor() {
        return databaseNotificationProcessor;
    }

    public void processDataUpdate(String payload) {
        needsRefreshing = true;
    }

    public void setNeedsRefreshing(Boolean needsRefreshing) {
        this.needsRefreshing = needsRefreshing;
    }

    public Boolean getNeedsRefreshing() {
//        boolean result = needsRefreshing;
//        if (needsRefreshing) {
//            refreshDataFromTable();
//            
//        }
//        needsRefreshing = false;

        return false;
    }
    
    public void empRefresh(ActionEvent ae) {
      refreshDataFromTable(null);
    }

}
