package nl.amis.app.view;


import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import nl.amis.app.model.DataUpdateEventListener;
import nl.amis.app.model.DatabaseNotificationHandler;

import oracle.adf.model.BindingContext;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCDataControl;
import oracle.adf.model.binding.DCIteratorBinding;

import oracle.binding.BindingContainer;

import oracle.jbo.uicli.binding.JUCtrlActionBinding;


public class DatabaseNotificationProcessor implements DataUpdateEventListener {

    private List<DataUpdateListenerI> listeners =
        new ArrayList<DataUpdateListenerI>();


    public DatabaseNotificationProcessor() {
        DatabaseNotificationHandler.addListener(this);
    }

    public void registerAsListener(DataUpdateListenerI listener) {
        listeners.add(listener);
    }

    public void processEvent(String entity, String context) {
        System.out.println("DatabaseNotificationProcessor is processing the event");
        for (DataUpdateListenerI listener : listeners) {
            listener.processDataUpdate(entity + new Date());
        }
    }
    
    private String iteratorName = "EmpView1Iterator";

}
